/*
  World alarm clock command manager
*/

#include <clock.h>

LOCAL_C INT LaunchDlg(UINT class,UINT id,VOID *prbuf)
{
  DL_DATA dl_data;
 
  dl_data.id = id;
  dl_data.rbuf = prbuf;
  dl_data.pdlg = NULL;
 
  return(hLaunchDial(CAT_CLOCK_CLOCK,class,&dl_data));
}

#pragma METHOD_CALL

METHOD VOID clockcm_com_exit(PR_CLOCKCM *self)
{
  INT clk;
  INT ret;
  VOID *fcb;

  hEnsurePath(filename);

  // rewrite file

  ret=p_open(&fcb,filename,P_FSTREAM|P_FRANDOM|P_FREPLACE|P_FUPDATE|P_FOPEN);

  if(!ret)
  {
	 for(clk=0;clk<NUM_CLOCKS;clk++)
	 {
      p_write(fcb,(TEXT *)p_send2(clocks[clk],O_GETCITY),22);
      p_write(fcb,(TEXT *)p_send2(clocks[clk],O_GETTITLE),22);
	 }
    p_write(fcb,(TEXT *)&sort,2);
    p_write(fcb,(TEXT *)&type,2);

	 p_close(fcb);
  }
  p_close(world);
  p_close(alm);

  for(clk=0;clk<NUM_CLOCKS;clk++)
  {
    p_send2(clocks[clk],O_DESTROY);
  }
  wFree(homeDate);
  wFree(homeTime);
  
  p_supersend2(self,O_COM_EXIT);
}

METHOD VOID clockcm_com_prefs(PR_CLOCKCM *self)
{
  INT clk,oldtype,oldsort;
  
  oldtype=type;
  oldsort=sort;

  if(LaunchDlg(C_PREFSDL,SET_PREFS,NULL))
  {
    if(type!=oldtype)
    {
      for(clk=0;clk<NUM_CLOCKS;clk++)
      {
        p_send3(clocks[clk],O_TYPE,type);

//	    p_send3(clocks[clk],O_SET,offset[clk]);
      }
    }
    if(sort!=oldsort)
    {
      Sort(FALSE);
    }
  }
}

METHOD VOID clockcm_com_alarm(PR_CLOCKCM *self)
{
  if(alarm->active.stat==E_FILE_PENDING)
	 wInfoMsg("Cannot set more than one alarm");
  else
    LaunchDlg(C_ALARMDL,SET_ALARM,NULL);
}

METHOD VOID clockcm_com_set(PR_CLOCKCM *self)
{
  LaunchDlg(C_SETUPDL,SET_CLOCK,NULL);
}

METHOD VOID clockcm_com_calc(PR_CLOCKCM *self)
{
  LaunchDlg(C_CALCDL,CALC_TIME,NULL);
}

METHOD VOID clockcm_com_cancel(PR_CLOCKCM *self)
//
// Cancel alarm menu option selected
//
{
  if(alarm->active.stat==E_FILE_PENDING)
  {
    p_send2(alarm,O_AO_CANCEL);

	 wInfoMsg("Alarm cancelled");
  }
  else
    wInfoMsg("No alarm pending");
}

