/*
ppcopl16.c
written by P.L.Edwards
version 1.00 July 1997
*/

#include "e:\ode\ppcbook\dyl\ppcopl16.h"

/*********************************************/
/* Convert p RAM in 16 byte paras to K bytes */
/*********************************************/
INT raminK(UINT p)
{
  ULONG ram ; 
  ram = p ;
  return (ram*16)/1024 ;
}

/**********************************************/
/* Start of Methods                           */
/**********************************************/
#pragma METHOD_CALL

/*************************************/
/* get system program RAM statistics */
/*************************************/
METHOD VOID ppcopl01_getram(PR_ROOT *self, INT *mem)
{ 
  UINT rm,rf,rd;        
  rm = p_getram();       /* get program RAM maximum  -NOTE need to include
                             EPOC.H for this PLIB function !!!!  */ 
  rf = p_sgfree();       /* get program RAM free i.e. 512 max */
  rd = p_sgramdisk();    /* get program RAM used by RAM disk */
  
  /* compiler may give warnings about loss of significant bits */
  /* but it's OK to ignore them */
  
  mem[0] = raminK(rm);        /* calc RAM in K */
  mem[1] = raminK(rf);        /* calc program RAM free in K */
  mem[2] = raminK(rm-rf-rd);  /* calc program RAM used by programs in K */
  mem[3] = raminK(rd);        /* calc program RAM used by RAM disk in K */
  
  return ;
} /* O_GETRAM */

/**********************************************/
/*   End of Methods                           */
/**********************************************/

