//
// Module bmppic.cpp
// DLL functions based on standard template
//
// Written by LCR, January 1995
// (C) Copyright Psion PLC 1995
//

#include	<windows.h>
#include	<string.h>
#include	"psiwinxm.h"
#include	"psiwinxl.h"
#include	"bmppic.h"

static	HINSTANCE	hInst;
static	lastErrorMsg[256];
void ErrorMessageProcessing(int);

int WINAPI _export LibMain(HANDLE hInstance, WORD wDataSeg, WORD cbHeapSize, LPSTR lpCmdLine)
	{
	if (cbHeapSize > 0)
    	UnlockData(0);
    hInst = hInstance;
	return 1;
	}

WORD WINAPI _export XLInstall(LPSTR lpPSPD)
	{
	return *(WORD *) lpPSPD;
	}

int WINAPI _export XLGetLastErrorMsg(LPSTR msg, int nMsg)
	{
	lstrcpyn(msg, (LPCSTR) lastErrorMsg, nMsg);
	lastErrorMsg[0] = '\0';
	return lstrlen(msg);
	}

int WINAPI _export XLSelectApp(LPSTR fileName)
	{                   
	char	fileHead[2];
	HFILE	hFile;
	
	if((hFile=_lopen(fileName,OF_READ))==HFILE_ERROR)
		{
		return 0;
		}           

	if(HFILE_ERROR==_lread(hFile,fileHead,2))
		{
		_lclose(hFile);
		return 0;
		}

	_lclose(hFile);

	if(fileHead[0]=='B' && fileHead[1]=='M')
		return 2;
	else
		return 0;
	}

int	WINAPI _export XLSelectFormat(LPSTR fileName)
	{
	char	fileHead[3];
	HFILE	hFile;
	
	if((hFile=_lopen(fileName,OF_READ))==HFILE_ERROR)
		{
		return 0;
		}           

	if(HFILE_ERROR==_lread(hFile,fileHead,3))
		{
		_lclose(hFile);
		return 0;
		}

	_lclose(hFile);

	if(fileHead[0]=='P' && fileHead[1]=='I' && fileHead[2]=='C')
		return 1;
	else
		return 0;
	}
                      
BOOL WINAPI _export XLExport(LPXMINFO xm,LPSTR sourceFile,LPSTR resultFile,WORD mode,XMSTATPROC statProc)
	{   
	BOOL	status;
    HGLOBAL	hPic,hBitmap;
    int		errorstate=0;                                   
    LPINT	esptr;
    
	esptr=&errorstate;
	// Load pic data
	hPic=LoadPic(sourceFile,esptr);
	if(hPic==NULL)
		{               
		ErrorMessageProcessing(errorstate);
		return(FALSE);
		}
	// Convert pic to dib
	hBitmap=ConvertPicToDib(hPic,statProc,esptr);
	if(hBitmap==NULL)
		{                                                    
		GlobalFree(hPic);
		ErrorMessageProcessing(errorstate);
		return(FALSE);
		}
	// Free pic resources
	GlobalFree(hPic);
	// Save dib data
	status=SaveDib(resultFile,hBitmap,esptr);
	if(status==FALSE)
		{                                                    
		GlobalFree(hBitmap);
		ErrorMessageProcessing(errorstate);
		return(FALSE);
		}
	// Free dib resources
	GlobalFree(hBitmap);
	return(TRUE);
	}

BOOL WINAPI _export XLImport(LPXMINFO xm, LPSTR sourceFile, LPSTR resultFile, WORD mode, XMSTATPROC statProc)
	{
	BOOL	status;    
    HGLOBAL	hBitmap=NULL;
    int		errorstate=0;
    LPINT	esptr;
    
	esptr=&errorstate;
	// Load dib data
	hBitmap=LoadDib(sourceFile,esptr);
	if(hBitmap==NULL)
		{                                                    
		ErrorMessageProcessing(errorstate);
		return(FALSE);
		}               
	status=SavePic(hBitmap,resultFile,statProc,esptr);
	// Free dib resources
	GlobalFree(hBitmap);
	if(status==FALSE)
		{
		ErrorMessageProcessing(errorstate);
		return(FALSE);
		}
	return(TRUE);
	}

void ErrorMessageProcessing(int errnum)
	{
	switch(errnum)
		{
		case 0:
			wsprintf((LPSTR) lastErrorMsg, "Unknown."); 
			break;
		case 1:
			wsprintf((LPSTR) lastErrorMsg, "File open failed."); 
			break;
		case 2:
			wsprintf((LPSTR) lastErrorMsg, "File read failed."); 
			break;
		case 3:
			wsprintf((LPSTR) lastErrorMsg, "Out of memory."); 
			break;
		case 4:
			wsprintf((LPSTR) lastErrorMsg, "Conversion too large."); 
			break;
		case 5:
			wsprintf((LPSTR) lastErrorMsg, "External termination."); 
			break;
		case 6:
			wsprintf((LPSTR) lastErrorMsg, "File creation failed."); 
			break;
		case 7:
			wsprintf((LPSTR) lastErrorMsg, "Memory corruption."); 
			break;
		case 8:
			wsprintf((LPSTR) lastErrorMsg, "File write failed."); 
			break;
		case 9:
			wsprintf((LPSTR) lastErrorMsg, "File close failed."); 
			break;
		case 10:
			wsprintf((LPSTR) lastErrorMsg, "Not a bitmap."); 
			break;
		case 11:
			wsprintf((LPSTR) lastErrorMsg, "Bitmap too large."); 
			break;
		case 12:
			wsprintf((LPSTR) lastErrorMsg, "Bitmap format not supported."); 
			break;
		}
	}