/*	PSIWINXM.H

/*	Revision History

	08-24-94	Original devided from NEWTONXM.H						CAS

*/

#ifndef	_INC_PSIWINXM
#define	_INC_PSIWINXM

#ifdef __cplusplus
	extern "C" {
#endif

#include	<windows.h>
#include	"psiwinxl.h"

#define	PSIWINXM_VERSION	0x0100

typedef HGLOBAL	HXM;

typedef	struct	tagPSXMCTL
{

	DWORD	dwLen;			/* Length of this control block				*/
	WORD	version;
	WORD	direction;		/* Direction of file transfer				*/

		#define	TO_PSION		0
		#define	FROM_PSION		1
		#define	FROM_CLIPBOARD	2
		#define	TO_CLIPBOARD	3

	WORD	psionFormat;	/* 1 based index to psionFormatListH entry	*/
	
		#define	ALL_PSION_FORMATS	0
		
	int		errorStatus;	/* Error status code						*/
	XMSTATPROC	statusProc;	/* Translation progress callback			*/
	WORD	applID;			/* Application to be imported/exported		*/
	WORD	applFlags;		/* Bit flags for controlling the translator	*/

		#define	PSXM_OVERWRITE		0x8000	/* Overwrite on export	*/
		#define	PSXM_APPEND			0x4000	/* Append on export		*/

	WORD	pathID;			/* Translation path for import/export		*/
	int		applIDCnt;
	HGLOBAL	applIDListH;	/* Handle to array of applID's				*/
	HGLOBAL	applFlagsListH;	/* Handle to array of applFlags				*/
	int		formatIDCnt;
	HGLOBAL	formatIDListH;	/* Handle to array of psionFormatID's		*/
	int		pathIDCnt;
	HGLOBAL	pathIDListH;	/* Handle to array of pathID's				*/
	int		sourceRefNum;	/* DOS file Handle of source file or -1		*/
	char	sourceFileName[128]; /* Full DOS path name of source file	*/
	char	resultFileName[128]; /* Full DOS path name of result file	*/ 
	char	xlateFolder[128]; /* DOS Path to xlator files				*/
	WORD	applCnt;		/* Number of applications in applListH		*/
	WORD	applListLen;	/* Length of applListH						*/
	HGLOBAL	applListH;		/* Handle to an array of application names	*/
	int		psionFormatCnt;	/* Number of Psion Formats Descriptors		*/
	HGLOBAL	psionFormatListH; /* Handle to array of PsionFormatInfo items*/
	WORD	pathDescCnt;	
	HGLOBAL	pathDescListH;
	WORD	filterExtCnt;
	WORD	filterExtListLen;
	HGLOBAL	filterExtListH;
	WORD	xmFileCnt;
	WORD	xmFileListLen;
	HGLOBAL	xmFileListH;
	DWORD	prefCategoryID;	/* Category ID for Preferences dialog		*/
	int		prefCnt;
	HGLOBAL	prefListH;		/* Handle to an array of NXPref records		*/
	int		commdlgFilterLen;
	HGLOBAL	commdlgFilterH;
	XMINFO	xmInfo;

}	PSXMCTL, FAR *LPPSXMCTL;


typedef	struct	tagPFINFO
{
	char	psionFormatName[32];
	char	psionFormatExt[4];
	char	psionFormatPath[32];

}	PFINFO, FAR *LPPFINFO;

typedef	struct	tagXMPATH
{
	WORD	pathFlags;
	int		nApp;
	char	appName[64];
	int     nFormat;
	char	formatName[32];

}	XMPATH,	FAR *LPXMPATH;

typedef	struct	tagPSPD
{

	WORD	fileID;
	WORD	applID;
	WORD	filterID;
	WORD	psionFormatID;
	WORD	pspdFlags;

}	PSPD, FAR *LPPSPD;

typedef struct	tagXMPREF
{

	DWORD	categoryID;
	char	categoryName[32];
	char	categoryFile[16];

}	XMPREF, FAR *LPXMPREF;

typedef	struct	tagXMPREFITEM
{

	DWORD	itemType;
	WORD	itemID;
	WORD	itemLen;
	void FAR *itemData;

}	XMPREFITEM,	FAR *LPXMPREFITEM;

typedef	int		(PASCAL FAR *PSXLPROC)(WORD, LPPSXMCTL, void FAR *);

/*	Prototypes	*/

PASCAL FAR _export	PsiWinXM(WORD, LPPSXMCTL);

	#define	XM_INSTALL		1
	#define	XM_NARROW		2
	#define	XM_SELECT		3
	#define	XM_IMPORT		4
	#define	XM_EXPORT		5
	#define	XM_RELEASE		6
	#define	XM_PREFS		7

PASCAL FAR _export	PsiWinXL(WORD, LPPSXMCTL, void FAR *);

	#define	XL_INSTALL		1
	#define	XL_SELECT		2
	#define	XL_IMPORT		3
	#define	XL_EXPORT		4
	#define	XL_FORMAT		5

#define	XL_EXTENSION	".PXL"

typedef	int		(PASCAL FAR *PSXPPROC)(WORD, LPPSXMCTL, void FAR *);

PASCAL FAR _export	PsiWinXP(WORD, LPPSXMCTL, void FAR *);

	#define	XP_INSTALL		1
	#define	XP_SETPREF		2
	#define	XP_GETPREF		3
	#define	XP_RELEASE		4

#define	XP_EXTENSION	".PXP"

#define	XM_MAX_PATH		144

#define	XM_MAX_PREF		512

#define	XMERR_UNKNOWN_FUNCTION			-1001
#define	XMERR_GLOBAL_LOCK				-1002
#define	XMERR_GLOBAL_ALLOC				-1003
#define	XMERR_GLOBAL_REALLOC			-1004
#define	XMERR_LOAD_LIBRARY				-1005
#define	XMERR_NO_LIBRARY				-1006
#define	XMERR_NO_PATH					-1007
#define	XMERR_MAX_PREF					-1008
#define	XMERR_UNKNOWN_FILE_FORMAT		-1009	// CAS
#define	XMERR_PASSWORD_PROTECTED		-1010	// CAS
#define	XMERR_AMBIGUOUS_FILE_FORMAT 	-1011	// CAS
#define XMERR_NOCLIP_AVAILABLE      	-1012	// Kostas
#define XMERR_LOW_MEMORY				-1030	// PAP
#define XMERR_UNKNOWN_CATEGORY			-1031	// PAP
#define XMERR_UNKNOWN_APPLICATION		-1032	// PAP
#define XMERR_NO_APPLICATION			-1033	// PAP Import/Export applID==0
#define XMERR_NO_APPLICATIONSFOUND 		-1034	// PAP No applications found on path
#define XMERR_GEN_XLATION_ERR	 		-1035	// Rich
#define XMERR_BAD_HANDLE		 		-1036	// Rich

#define	XLERR_UNKNOWN_FUNCTION			-2001
#define	XLERR_FILE_PROTECTED			-2002
#define	XLERR_XLATION_COMP_NOT_FOUND	-2003
#define	XLERR_UNKNOWN_FILE_FORMAT		-2009

#define	XPERR_UNKNOWN_FUNCTION			-3001
#define	XPERR_FILE_PROTECTED			-3002

HXM WINAPI  XMOpen(LPSTR psionName, LPSTR xlateFolder, HWND hParent);
/*
			psionName is a name for the connected Psion, to track user specific
            preferences and field mappings.  If none is available, set this to
            NULL and we will assume guest access

            xlateFolder is the DOS pathName to the directory where the
            translators will be stored.

            hParent is the HWND of a window that will be used as the parent
            window in bringing up dialogs, such as field naming and mapping.
*/
BOOL WINAPI XMClose(HXM hXM);
/*
            hXM is the HXM returned by XMOpen(), a translation context handle
*/
BOOL WINAPI XMSetDirection(HXM hXM, int direction);
/*
            hXM is a translation context handle

            direction is the direction of transfer

            Setting the direction causes the list of available translators
            and associated applications to be narrowed to reflect the indicated
            direction.

            Returns TRUE if the function was successful
*/
BOOL WINAPI XMSetFormat(HXM hXM, int nFormatID);
/*
			hXM is a translation context handle

            nFormatID is a one-based index into the list of known Psion
            formats, based on the installed translators.  An nFormatID of
            zero is the special case of ALL_AVAILABLE_FORMATS.

            Setting the Host Format causes the list of available translators
            and associated applications to be narrowed to reflect the indicated
            Host Format.

            Returns TRUE if the function was successful
*/
BOOL WINAPI XMSetApp(HXM hXM, int nApp);
/*
            hXM is a translation context handle

            nApp is the one-based index of the application to exchange. An nApp of
            zero is the special case of ALL_AVAILABLE_APPS

            Returns TRUE if the function was successful
            
*/
BOOL WINAPI XMSetPath(HXM hXM, int nPath);
/*
			hXM is a translation context handle

            nPath is a one-based index into the list of selected
            translation paths.

            Setting the translation path selects a specific translator for
            import or export.

            Returns TRUE if the function was successful
*/
int WINAPI  XMSelectApp(HXM hXM, LPSTR pszSourceFile);
/*
            hXM is a translation context handle

            pszSourceFile is the DOS path name of the file to be translated
            
            Returns a translator selection status as follows:

            0 - No translator is available for this file
            -1 - This file is password protected
            
            or
            
            The number of possible translation paths
*/
int WINAPI  XMSelectFormat(HXM hXM, LPSTR pszSourceFile);
/*
            hXM is a translation context handle

            pszSourceFile is the DOS path name of the file to be translated

            Returns a host format index or as follows:

            0  - Host Format is unknown
            -1 - This file is password protected
*/

//		Q U E R I E S

//			COMMDLG Filter

int WINAPI  XMGetFilterLen(HXM hXM);
/*
            hXM is a translation context handle

            Returns the length of the COMMDLG filter string
*/
int WINAPI  XMGetFilter(HXM hXM, LPSTR pszFilter, int nFilter);
/*
            hXM is a translation context handle

            pszFilter is a buffer that will receive the COMMDLG filter string

            nFilter is the size of the COMMDLG filter string buffer

            Returns the number of bytes copied to pszFilter
*/

//			Apps

int WINAPI  XMCountApps(HXM hXM);
/*
            hXM is a translation context handle

            Returns the number of known Application Formats,i.e., the numer of
            Application Formats for which there are translators, based on the 
            current Host Format and direction.
*/
int WINAPI  XMGetAppNameLen(HXM hXM, int nApp);
/*
            hXM is a translation context handle

            nApp is the one-based index of the application

            Returns the length in bytes of the name corresponding to nApp,
            not counting the trailing '\0'
*/
int WINAPI  XMGetAppName(HXM hXM, int nApp, LPSTR pszAppName, int nAppName);
/*
            hXM is a translation context handle

            nApp is the one-based index of the application

            pszAppName is the buffer that will receive the application name

            nAppName is the size of the application name buffer

            Returns the number of bytes transfered to pszAppName, not counting
            the trailing '\0'
*/

//			Formats

int WINAPI  XMCountFormats(HXM hXM);
/*
            hXM is a translation context handle

            Returns the number of known Psion Formats,i.e., the numer of
            Psion Formats for which there are translators.
*/
BOOL WINAPI XMGetFormatInfo(HXM hXM, int nFormat, LPPFINFO lpPFI);
/*
            hXM is a translation context handle

            formatID is a one-based index into the list of known Psion
            formats, based on the installed translators.  A formatID of 0
            is a special case of ALL_AVAILABLE_FORMATS.

            Setting the Host Format causes the list of available translators
            and associated applications to be narrowed to reflect the indicated
            Host Format.

            Returns TRUE if the function was successful
*/

//			Paths

int WINAPI	XMCountPaths(HXM hXM);
/*
            hXM is a translation context handle

            Returns the number of available translation paths based on the current
            direction, format and application selected.
*/
BOOL WINAPI	XMGetPathInfo(HXM hXM, int nPath, LPXMPATH lpPath);
/*
			hXM is a translation context handle
			
			nPath is the one-based index of the translation path
			
			lpPath points to the XMPATH structure that will receive the
			information about the indicated translation path

            Returns TRUE if the function was successful
*/

//			Prefs

int WINAPI	XMCountPrefs(HXM hXM);
/*
            hXM is a translation context handle

            Returns the number of preference categories
*/
BOOL WINAPI XMGetPrefInfo(HXM hXM, int nPref, LPXMPREF lpPref);
/*
			hXM is a translation context handle
			
			nPref is the one-based index of the preference
			
			lpPref points to the XPINFO structure that will receive the
			information about the indicated translation preference

            Returns TRUE if the function was successful
*/
BOOL WINAPI XMSetPref(HXM hXM, int nPref);
/*
			hXM is a translation context handle
			
			nPref is the one-based index of the preference

			The dialog controlling preference nPref will be invoked.
						
            Returns TRUE if the function was successful
*/
int WINAPI	XMGetCurrentFormat(HXM hXM);
/*
			hXM is the translation context handle
			
			Returns 0 or the index of the currently selected hostFormat
*/
int WINAPI	XMGetCurrentApp(HXM hXM);
/*
			hXM is the translation context handle
			
			Returns 0 or the index of the currently selected application
*/

int WINAPI XMGetTransferMode(HXM hXM);
/*
            hXM is a translation context handle

            Returns the available transfer modes of the currently
            selected translator.  The available modes are as follows:

            1 - Overwrite
            2 - Append
            4 - Merge/Update
            8 - Synchronize

            A transfer mode should then be selected for the Import or Export
            operation.
*/
BOOL WINAPI XMImport(HXM hXM, LPSTR pszSource,  LPSTR pszResult, int nMode, XMSTATPROC statProc);
/*
            hXM is a translation context handle

            pszSource is the DOS path name of the source file

            pszResult is the DOS path name of the result file

            nMode is the transfer mode to be used by the translator
            as follows:

            1 - Overwrite
            2 - Append
            4 - Merge/Update
            8 - Synchronize
                        
            Returns TRUE if the function was successful
*/
BOOL WINAPI XMExport(HXM hXM, LPSTR pszSource,  LPSTR pszResult, int nMode, XMSTATPROC statProc);
/*
            hXM is a translation context handle

            pszSource is the DOS path name of the source file

            pszResult is the DOS path name of the result file

            nMode is the transfer mode to be used by the translator
            as follows:

            1 - Overwrite
            2 - Append
            4 - Merge/Update
            8 - Synchronize
                        
            Returns TRUE if the function was successful
*/
int WINAPI XMGetLastErrorMsg(HXM hXM, LPSTR pszMsg, int nMsg);
/*
            hXM is a translation context handle

            pszMsg is a buffer to receive the error message

            nMsg is the size of the pszMsg buffer

            Returns the number of characters actually copies to pszMsg,
            not including the trailing '\0'
*/

#ifdef __cplusplus
	}
#endif

#endif	//	_INC_PSIWINXM
