// Wav <-> Wve conversion header file
// Written by JP, Jan 1995
// (C) Copyright Psion PLC

// Defs for VC2.0 compatibility

#if defined(__VC32__)
	#define EXPORT_C __declspec(dllexport)
	#define IMPORT_C __declspec(dllimport)
	#define _export
	#define READ OF_READ
	#define WRITE OF_WRITE
	#define READ_WRITE OF_READWRITE
#else
	#define EXPORT_C
	#define IMPORT_C
#endif 

// Defs for WAV -> WVE conversion
#define ALawSignature "ALawSoundFile**"
#define SignatureSize 16
#define MAGICXOR 0x2a
#define ONE 1
#define BIT8 0x80 
#define MASK2 0x03
#define MASK4 0x0f
#define MASK8 0xff            
#define SIXTEEN_BIT (WAVE_FORMAT_1M16 | WAVE_FORMAT_1S16 | WAVE_FORMAT_2M16 | WAVE_FORMAT_2S16 | WAVE_FORMAT_4M16 | WAVE_FORMAT_4S16)    
// Defs for WVE -> WAV conversion
#define XORMASK 0x55
#define BIT8 0x80
#define MASK3 0x70
#define MASK4 0x0f
#define MASK8 0xff
#define WAVSAMPLERATE 11025.0
#define WVESAMPLERATE 8000.0

typedef enum
	{
	WPanicBufferOverflow,
	WPanicCalculationOverflow,
	WPanicTooMuchOutput,
	WPanicSilenceAtEndOverflow
	} WavConvPanic;
	
typedef enum
	{
	WInfConvIncomplete,
	WInfConvCompleted
	} WavConvInf;

// typedef enum
//    {
#define WErrUndefined 					10
#define WErrOpeningWAVfile 				11
#define WErrCreatingFile				12
#define WErrReadingFile					13
#define	WErrBadWAVformat				14
#define	WErrUnexpectedChannel			15
#define	WErrStrangeSampleRates			16
#define	WErrUnexpectedDataSize			17
#define WErrModeNotSupported			18
#define WErrNoStatusRtn					19
#define WErrUnexpectedBytesPerSample	20
#define WErrUnexpectedFormatTag			21
#define WErrOpeningWVEfile				22
#define WErrIncorrectHeaderLength		23
#define WErrWritingWVEheader			24
#define WErrBadWVEformat				25
#define WErrStatusReturnTrue 			26
#define WErrWritingData 				27
#define WErrWritingWAVheader 			28
//    } WavConvErr;

typedef struct
    {
    char Signature[SignatureSize];
    unsigned short Version;
    unsigned long Samples;
    unsigned short SilenceInTicks;
    unsigned short Repeats;
    unsigned short Spare[3];
    } SndFile;

typedef struct
    {
    char Signature[4];           /* ="RIFF"; */
    unsigned long TotalFileLength;
    char Format[8];              /* ="WAVEfmt "; */
    long HeaderLength;          /* =16; */
    short FormatTag;             /* =1; */
    short ChannelNo;             /* =1; */
    long SampleRate;            /* =11025; */
    long BytesXSample;          /* =11025; */
    short BytesPerSample;        /* =1; */
    short EightXBytes;           /* =8; */
    char DataMark[4];            /* ="data"; */
    unsigned long DataLength;
    } WAVTemplate;

