/* EXAMPLE OF LOADING THE SYS$8087 FLOATING POINT EMULATOR ON A
SIBO MACHINE. */

#ifdef EPOC
#include <p_std.h>
#include <p_file.h>
#include <epoc.h>

#define NULL_TXT ((TEXT *)0)

LOCAL_C UINT try_ldd_in(TEXT * where_ldd);
LOCAL_C void get_app_name(TEXT * result);

LOCAL_D void * em_handle=0;

LOCAL_D TEXT fp_em_name[] = "EM$:";

GLREF_D TEXT * DatCommandPtr;

GLDEF_C UINT fp_init(void)
/* Return TRUE if it managed to install the 8087 emulator s/w	*/
    {
    TEXT app_name[P_FNAMESIZE];

    if (!em_handle	/* if not already initialised	*/
	&& p_open(&em_handle, fp_em_name, -1) <0) /* & not already loaded	*/
	{
	get_app_name(app_name);
	if (!try_ldd_in(        "ROM::")
		&& !try_ldd_in( app_name)
		&& !try_ldd_in( "")
		&& !try_ldd_in( "A:\\")
		&& !try_ldd_in( "B:\\")
		&& !try_ldd_in( "C:\\")
		&& !try_ldd_in( "D:\\"))
	    return FALSE; /* can't find it anywhere	*/
	}
    return TRUE;
    }

GLDEF_C void fp_shutdown(void)
    {
    p_close(em_handle);
    p_devdel("EM$", E_LDD);
    em_handle = 0;
    }

LOCAL_C void get_app_name(TEXT * result)
    {
    result[0] = 0;
    if (DatCommandPtr)
	{
	* p_skipch(DatCommandPtr) = 0;
	p_fparse(DatCommandPtr, /* the name */
		NULL_TXT,	/* no related name */
		result,		/* to take the full name */
		(P_FPARSE *)0);
	}
    }

LOCAL_C UINT try_ldd_in(TEXT * where_ldd)
    {
    TEXT full_name[P_FNAMESIZE];
    INT err;

    em_handle = 0;
    if (p_fparse("SYS$8087.LDD",
		    where_ldd, /* related name */
		    full_name,
		    (P_FPARSE *)0) >= 0)
	{
	err = p_loadldd(full_name);
	if (err >=0 || err == E_FILE_EXIST)
	    {
	    if (p_open(&em_handle, fp_em_name, -1) >=0)
        	return TRUE;
	    fp_shutdown();
	    }
	}
    return FALSE;
    }
#endif
