/*	PARENT.C
Parent program to demo child program printing to the parent window
Written by NSM, June 1995
Copyright (C) Psion PLC 1995
*/
#include "intf.h"

GLREF_D TEXT *DatCommandPtr;

LOCAL_C VOID panic(TEXT *aMess,INT anErr)
/*
Output error message and terminate program.
*/
    {
    TEXT buf[0x40];

    if (anErr)
		{
		p_errs(&buf[0],anErr);
		p_printf("Error: %s failed - %s",aMess,&buf[0]);
		}
    else
		p_printf("Error: %s",aMess);
    p_getch();
    p_exit(TRUE);
    }

LOCAL_C INT runChild(TEXT *aName,TEXT *aCommand)
/*
Run a child program.
*/
	{
	INT r,firstRequest;
	HANDLE h;
	WORD printStat,childStat;
	WORD *childStatPtr,zero;
	COMMAND_LINE_INFO info;
	TEXT buf[MAX_BUFFER];

	info.pid=p_getpid(); /* Set the parents pid */
	info.status=(&printStat); /* The address of a status word */
	info.buffer=(&buf[0]); /* The address of the buffer for the data */
	p_scpy(&info.restOfCommand[0],aCommand); /* The actual command line */
	h=p_execc(aName,&info,sizeof(COMMAND_LINE_INFO)); /* Execute the child */
	if (h<0)
		panic("Exec the child program",h);
	r=p_logona(h,&childStat); /* Completes when child dies */
	if (r<0)
		panic("Logging on to child program",r);
	zero=0;
	firstRequest=TRUE;
	printStat=E_FILE_PENDING; /* Waiting for a signal from the child to print something */
	p_presume(h); /* Resume the child */
	FOREVER
		{
		p_iowait(); /* Wait for either a print request or the child to die */
		if (childStat!=E_FILE_PENDING) /* Was it the child dying */
			break;
		if (printStat!=E_FILE_PENDING) /* Was it a print request */
			{
			if (firstRequest) /* It it the first request from the child */
				{
/*
On the first request the buffer will contain the address of the
childs status word. Thereafter it will contain data to print.
*/
				childStatPtr=(*((WORD **)&buf[0]));
				firstRequest=FALSE;
				}
			else
				p_printf(&buf[0]); /* Print the requested data */
			printStat=E_FILE_PENDING; /* Waiting for another request */
			p_pcpyto(h,childStatPtr,&zero,sizeof(zero)); /* Set the child's status to 0 */
			p_iosignalbypid(h); /* Signal the child that we have completed the request */
			}
		else
			panic("Stray signal",0); /* Signal not from something we know about */
		}
	return(childStat); /* Return the childs completion status */
	}

GLDEF_C INT main()
/*
The main program.
*/
	{
	INT r;
	TEXT childName[P_FNAMESIZE];

	p_printf("Test sharing windows V1.0");
	if ((r=p_fparse("CHILD.IMG",DatCommandPtr,&childName[0],NULL))<0)
		panic("Parse child name",r);
	p_printf("Running child %s",&childName[0]);
	r=runChild(&childName[0],"Hello world");
	p_printf("Child exit code %d",r);
	p_printf("Press any key");
	p_getch();
	return(0);
	}

