#include <plib.h>
#include <wlib.h>
#include <p_xmodem.h>

LOCAL_D INT				ret;

LOCAL_D VOID		*	Channel;

LOCAL_D VOID		*	pDebugFile;
LOCAL_D UINT			DebugFileMode;


LOCAL_C INT Check(INT val, TEXT *msg)
    {
    TEXT		buf[50];

    if (val >= 0)
		{
		p_iow(pDebugFile, P_FFLUSH);
		return val;
		}
    p_atos(&buf[0],"Error : %s",msg);
    p_notifyerr(val,&buf[0],0,0,0);
    p_exit(0);
    }


LOCAL_C VOID OpenDebugFile(TEXT *name)
	{
	DebugFileMode	=	P_FTEXT | P_FREPLACE | P_FUPDATE;

	Check(p_open(&pDebugFile, name, DebugFileMode), "opening debug file");
	}


LOCAL_C VOID CDECL DebugMessArg(TEXT *fmt, UINT arg, ...)
	{
	UINT				len;
	TEXT				buf[256];

	len	=	p_atob(&buf[0], fmt, &arg);
	Check(p_write(pDebugFile, &buf[0], len), "writing debug file");
	}


LOCAL_C VOID DebugMess(TEXT *mess)
	{
	Check(p_write(pDebugFile, mess, p_slen(mess)), "writing debug file");
	}


LOCAL_C VOID CloseDebugFile(VOID)
	{
	Check(p_iow(pDebugFile, P_FFLUSH), "flushing debug file");
	Check(p_close(pDebugFile), "closing debug file");
	}

	
LOCAL_C VOID LoadDriver(VOID)
	{
	DebugMess("About to load LDD");
	p_printf("About to load LDD");
	p_getch();
	Check(p_loadldd("loc::c:\\img\\sys$xmym.ldd"), "Loading LDD");
	DebugMess("Loaded LDD OK");
	p_printf("Loaded LDD OK");
	p_getch();
	}

	
LOCAL_C VOID OpenSerialPort(VOID)
	{
	DebugMess("About to open serial channel");
	p_printf("About to open serial channel");
	p_getch();
	Check(p_open(&Channel, "TTY:A", -1), "opening a channel to TTY:A");
	DebugMess("Opened serial channel OK");
	p_printf("Opened serial channel OK");
	p_getch();
	}

	
LOCAL_C VOID OpenChannel(VOID)
	{
	DebugMess("About to open channel to XMD");
	p_printf("About to open channel to XMD");
	p_getch();
	Check(p_open(&Channel, "XMD:", -1), "opening a channel to XMD:");
	DebugMess("Opened XMODEM channel OK");
	p_printf("Opened XMODEM channel OK");
	p_getch();
	}

	
LOCAL_C VOID Connect(VOID)
	{
	UWORD				type;
	UWORD				mode;

	type	=	P_XMDM_ACCP;
	mode	=	P_XMDM_CRCORCHECKSUM;

	DebugMess("About to connect to remote");
	p_printf("About to connect to remote");
	p_getch();
	Check(p_iow4(Channel, P_FCONNECT, &type, &mode), "Connecting to remote");
	DebugMess("Connected to remote OK");
	p_printf("Connected to remote OK");
	p_getch();
	}


LOCAL_C VOID WriteData(VOID)
	{
	VOID			*	File;
	UWORD				len;
	TEXT				SendBuf[130];
	UINT				Counter = 0;

	DebugMess("About to open send file");
	p_printf("About to open send file");
	Check(0, "dummy");

	p_open(&File, "loc::m:\\wrd\\file.wrd", P_FOPEN|P_FSTREAM);

	DebugMess("About to write data to remote");
	p_printf("About to write data to remote");
	Check(0, "dummy");

/*  Panic 60 in here somewhere  --------------------------------------------  */

while ((len = p_read(File, &SendBuf[0], 128)) > 0)
		{
		p_printf("Read %u block (%u bytes) from file", ++Counter, len);
		p_getch();
		p_printf("About to write %u bytes to XMD:", len);
		if (ret	=	p_iow(Channel, P_FWRITE, &SendBuf[0], &len))
			{
			p_printf("Error writing driver was %d", ret);
			p_getch();
			break;
			}
		}

/*  ------------------------------------------------------------------------  */


	DebugMess("Wrote data OK");
	p_printf("Wrote data OK");
	Check(0, "dummy");

	if (!ret && (!len || len==E_FILE_EOF))
		{
		len	=	0;
		p_iow(Channel, P_FWRITE, &SendBuf[0], &len);
		}
	p_close(File);
	
	DebugMess("Wrote whole file to remote OK");
	p_printf("Wrote whole file to remote OK");
	p_getch();
	}


LOCAL_C VOID Disconnect(VOID)
	{
	DebugMess("About to disconnect from remote");
	p_printf("About to disconnect from remote OK");
	p_getch();
	Check(p_iow2(Channel, P_FDISCONNECT), "Disconnecting from remote");
	DebugMess("Disconnected from remote OK");
	p_printf("Disconnected from remote OK");
	p_getch();
	}


LOCAL_C VOID CloseChannel(VOID)
	{
	Check(p_close(Channel), "closing channel to XMD:");
	p_printf("Closed XMODEM channel OK");
	p_getch();
	}

LOCAL_C VOID CloseSerialPort(VOID)
	{
	Check(p_close(Channel), "closing channel to TTY:A");
	p_printf("Closed serial channel OK");
	p_getch();
	}

	
GLDEF_C VOID main(VOID)
	{
	HANDLE				dummy	=	0;
	TEXT				buf[E_MAX_NAME + 2];

	OpenDebugFile("loc::m:\\wrd\\debug.wrd");

	if ((p_devfnd(dummy, "*XMD*", E_LDD, &buf[0])) < 0)
		LoadDriver();

	OpenSerialPort();
	OpenChannel();
	Connect();
	WriteData();
	Disconnect();
	CloseChannel();
	CloseSerialPort();
	CloseDebugFile();
	p_printf("Press any key");
	p_getch();
	p_exit(0);
	}

