#include <plib.h>

#include <wlib.h>



#include <p_serial.h>

#include <p_cons.h>



#define 				BAR_BUF_LEN				255





GLREF_D VOID		*	winHandle;



LOCAL_D VOID		*	pDebugFile;

LOCAL_D UINT			DebugFileMode;



LOCAL_D VOID		*	SerialPort;



LOCAL_D WORD			KeyStat;

LOCAL_D WORD			SerStat;





LOCAL_C INT Check(INT val, TEXT *msg)

    {

    TEXT		buf[50];



    if (val >= 0)

        return val;

    p_atos(&buf[0],"Error : %s",msg);

    p_notifyerr(val,&buf[0],0,0,0);

    p_exit(0);

    }





LOCAL_C VOID OpenDebugFile(TEXT *name)

	{

	DebugFileMode	=	P_FTEXT | P_FREPLACE | P_FUPDATE;



	Check(p_open(&pDebugFile, name, DebugFileMode), "opening debug file");

	}





LOCAL_C VOID CDECL DebugMessArg(TEXT *fmt, UINT arg, ...)

	{

	UINT				len;

	TEXT				buf[256];



	len	=	p_atob(&buf[0], fmt, &arg);

	Check(p_write(pDebugFile, &buf[0], len), "writing debug file");

	}





LOCAL_C VOID DebugMess(TEXT *mess)

	{

	Check(p_write(pDebugFile, mess, p_slen(mess)), "writing debug file");

	}





LOCAL_C VOID CloseDebugFile(VOID)

	{

	Check(p_iow(pDebugFile, P_FFLUSH), "flushing debug file");

	Check(p_close(pDebugFile), "closing debug file");

	}





LOCAL_C VOID OpenConsole(VOID)

	{

	P_RECT				rect;

	UWORD				func;



	rect.tl.x	=	0;

	rect.tl.y	=	0;

	rect.br.x	=	25;

	rect.br.y	=	9;



	func	=	P_SCR_WSET;



	Check(p_open(&winHandle, "CON:", 0xffff), "opening console");

	p_iow(winHandle, P_FSET, &func, &rect);

	}



	

LOCAL_C VOID OpenSerialPort(VOID)

	{

	Check(p_open(&SerialPort, "TTY:G", 0xffff), "opening channel to serial port");

	}



	

LOCAL_C VOID SetSerialPort(VOID)

	{

	P_SRCHAR			Settings;



	Settings.tbaud		=	P_BAUD_9600;

	Settings.rbaud		=	P_BAUD_9600;

	Settings.frame		=	P_DATA_8;

	Settings.parity		=	0;

	Settings.hand		=	0;

	Settings.xon		=	0x11;

	Settings.xoff		=	0x13;

	Settings.flags		=	0;

	Settings.tmask		=	0x00002000L;

	

	Check(p_iow(SerialPort, P_FSET, &Settings), "setting the port");

	}

	

	

LOCAL_C VOID ProcessKey(UWORD key)

	{

	if (key == W_KEY_ESCAPE)

		p_exit(0);

	else

		p_print("%s\n\r", "CANCELLED");

	}

	

	

LOCAL_C VOID ProcessBar(TEXT * bar, UWORD len)

	{

	bar[len - 1]	=	0;

	p_print("%s\n\r", &bar[0]);

	}

	

	

LOCAL_C VOID MainLoop(VOID)

	{

	TEXT				SerBuf[BAR_BUF_LEN];

	UWORD				SerLen	=	BAR_BUF_LEN;

	P_CON_KBREC			KeyPress;



	p_ioc(winHandle, P_FREAD, &KeyStat, &KeyPress);

	p_ioc(SerialPort, P_FREAD, &SerStat, &SerBuf[0], &SerLen);



	FOREVER

		{

		p_iowait();



		if (SerStat != E_FILE_PENDING)

			{

			if (SerStat != 0)

				p_printf("Error reading");

			else

				ProcessBar(&SerBuf[0], SerLen);



			SerLen	=	BAR_BUF_LEN;

			p_ioc(SerialPort, P_FREAD, &SerStat, &SerBuf[0], &SerLen);

			}

		else if (KeyStat != E_FILE_PENDING)

			{

			ProcessKey(KeyPress.keycode);

			p_ioc(winHandle, P_FREAD, &KeyStat, &KeyPress);

			}

		else

			p_panic(143);                                   /*  Stray signal  */

		}

	}

	

	

GLDEF_C VOID main(VOID)

	{

	OpenConsole();

	OpenSerialPort();

	SetSerialPort();

	MainLoop();

	}

