/*	PSIWINXL.H	-	PsiWin External Translator API Definition	*/

/*	Copyright DataViz, Inc, 1994 - All Rights Reserved.			*/

/*	Revision History

	09-09-94	Original - CAS

*/

#ifndef	_INC_PSIWINXL

#define	_INC_PSIWINXL

#ifdef __cplusplus
	extern "C" {
#endif

#include	<windows.h>

typedef struct tagXMINFO
{
	HWND		hwndHost;
	HINSTANCE	hInstXM;
	LPSTR		pszHostName;

}	XMINFO, FAR *LPXMINFO;


typedef	BOOL	(WINAPI *XMSTATPROC)(int);

WORD WINAPI XLInstall(LPSTR lpPSPD);
/*
	This routine is called to conditionally install the translator.  It
	returns the pathFlags WORD for this translation path or zero
	if the translator is NOT to be installed.

	lpPSPD points to the resource that describes this translator.
*/

int WINAPI	XLSelectApp(LPSTR fileName);
/*
	This routine answers whether the indicated file is the application
	format exchanged by this translation path.

	Returns:

	0	The file is not this application format
	1	The file may be this application format
	2	The file is definitely this application format
	3	The file is definitely this application format, but is
		password protected
*/

int WINAPI	XLSelectFormat(LPSTR fileName);
/*
	This routine answers whether the indicated file is of the OEM 
	format exchanged by this translation path.

	Returns:

	-1	The file is this OEM format, but is password protected
	0	The file is not this OEM format
	1	The file is definitely this OEM format
*/

BOOL WINAPI	XLImport(LPXMINFO xminfo, LPSTR sourceFile, LPSTR resultFile, WORD xferMode,
						XMSTATPROC statusRtn);
/*
	This routine imports from the sourceFile to the indicated resultFile
	per the requested transfer mode.  The available transfer modes are

	1 - Overwrite
	2 - Append
	4 - Merge/Update
	8 - Synchronize

	Translation status is reported as a percent complete by calling the
	statusRtn.  A statusRtn return of TRUE indicates that the translation
	should be cancelled.

	Returns TRUE if the translation is sucessful, FALSE otherwise.
*/

BOOL WINAPI	XLExport(LPXMINFO xminfo, LPSTR sourceFile, LPSTR resultFile, WORD xferMode,
						XMSTATPROC statusRtn);
/*
	This routine exports from the sourceFile to the indicated resultFile
	per the requested transfer mode.  The available transfer modes are

	1 - Overwrite
	2 - Append
	4 - Merge/Update
	8 - Synchronize

	Translation status is reported as a percent complete by calling the
	statusRtn.  A statusRtn return of TRUE indicates that the translation
	should be cancelled.

	Returns TRUE if the translation is sucessful, FALSE otherwise.
*/

int WINAPI	XLGetLastErrorMsg(LPSTR msg, int nMsg);
/*
	This routine copies the error message string associated with the 
	last error to the indicated buffer transfering up to nMsg bytes
	including the trailing '\0' character.

	Returns the length of the string returned or 0 if there is no last
	error.
*/

int	WINAPI	_export	XLCopy2ClipBoard(LPXMINFO info, LPSTR sourceFile);
/*
  	This routine xlates the sourcefile into RTF format and TEXT format and
  	then it pastes them into CLIPBOARD.
  	
  	Returns 0 if there is no error otherwise an error message
*/                                                           

typedef	WORD (WINAPI *XLINSTALLPROC)(LPSTR);
typedef int (WINAPI *XLSELECTPROC)(LPSTR);
typedef	BOOL (WINAPI *XLXLATEPROC)(LPXMINFO, LPSTR, LPSTR, int, XMSTATPROC);
typedef	int (WINAPI *XLERRORPROC)(LPSTR, int);
typedef	int (WINAPI *XLCOPYCLPPROC)(LPXMINFO, LPSTR);     

#ifdef __cplusplus
	}
#endif


#endif	//	_INC_PSIWINXL

