// SOLTASK.C - Solipeg tasks

// This file includes methods for:

// Tasks - the core of the undo engine

#include <plib.h>
#include <solipeg.g>
#include <solipeg.rsg>
#include <hwim.h>
#include <solglob.h>



#pragma save, METHOD_CALL



#undef this
#define this    (self->jump)


// Initialize an object of class jump
METHOD VOID jump_task_init( PR_JUMP *   self,
                            INT         x,
                            INT         y,
                            INT         dir ) {
    this.x = x ;
    this.y = y ;
    this.dir = dir ;
}

// Do a jump
METHOD VOID jump_task_do(   PR_JUMP *   self,
                            PR_SOLENG * engine ) {
    p_send5(engine, O_ENG_JUMP, this.x, this.y, this.dir) ;
}

// Undo a jump
METHOD VOID jump_task_undo( PR_JUMP *   self,
                            PR_SOLENG * engine ) {
    p_send5(engine, O_ENG_UNJUMP, this.x, this.y, this.dir) ;
}

// Return a suitable description of a jump
METHOD VOID jump_task_text( PR_JUMP *   self,
                            TEXT *      str ) {
    hLoadResBuf(RS_TASK_JUMP, str) ;
}

